//  Copyright 1999, Joseph Bergin. All rights reserved.

import kareltherobot.*;
import java.awt.Color;

public class Philosopher extends AugmentedRobot implements Runnable, Directions
{	public Philosopher(int street, int avenue,  Direction direction)
	{	super(street, avenue, direction, 0);
		World.setupThread(this);
		if(World.delay() == 0) World.setDelay(1); // May not run well at fastest speed. 
	}
	
	public Philosopher(int street, int avenue, Direction direction, Color badge)
	{	super(street, avenue, direction, 0, badge);
		World.setupThread(this);
		if(World.delay() == 0) World.setDelay(1); // May not run well at fastest speed. 

	}
	
	public void run()
	{	while(true)
		{	think(d.roll());
			getForks();
			eat(d.roll());
			putForks();
		}
	}
	
	private void think(int time)
	{	for(int i = 0; i < time; ++i)
		{	backUp();
			move();
		}
	}
	
	private void eat(int time)
	{	userPause("eat");
		for(int i = 0; i < time; ++i)
		{	move();
			backUp();
		}
	}
	
	private void getForks()
	{	turnLeft();
		move();
		while(! anyBeepersInBeeperBag())
		{	while(! nextToABeeper()) ; // nothing
			pickBeeper();
		}
		turnAround();
		move();putBeeper();
		move();
		while(! anyBeepersInBeeperBag())
		{	while(! nextToABeeper()) ; // nothing
			pickBeeper();
		}
		turnAround();
		move();
		putBeeper();
		turnRight();
		showState("Eat ");
	}
	
	private void putForks()
	{	pickBeeper();
		pickBeeper();
		turnLeft();
		move();
		putBeeper();
		turnAround();
		move();
		move();
		putBeeper();
		turnAround();
		move();
		turnRight();
		showState("Think ");
	}
	
	Die d = new Die(6);
}

/* To run this you say something like:

		World.placeBeepers(2, 2, 1);
		World.placeBeepers(2, 4, 1);
		World.placeBeepers(4, 2, 1);
		World.placeBeepers(4, 4, 1);
		Philosopher p1 = new Philosopher(2, 3, North);
		Philosopher p2 = new Philosopher(3, 2, East);
		Philosopher p3 = new Philosopher(4, 3, South);
		Philosopher p4 = new Philosopher(3, 4, West);

in your main program.

*/ 